/********************************************************************/
/*   7188EX + X202 head file                                        */
/*                                                                  */
/*   [October/07/2005] by Liam                                      */
/********************************************************************/
/********************************************************************/
/*  X202: 7 channels A/D (0~20mA)                                   */
/*                                                                  */
/* [Caution]                                                        */
/*	 The EEPROM block 7 on X board is used to store A/D & D/A       */
/*  calibration settings.                                           */
/*                                      	                        */
/*  When you use the  EEPROM on X board, don't overwrite it.        */
/********************************************************************/

int X202_Init(void);
/*  Return value: 0   ==> success
    Return value: <>0 ==> error
    Bit0: 1 ==> (Ch0)Reads A/D Gain falure
    Bit1: 1 ==> (Ch0)Reads A/D Offset falure    */
    
float Read_AD_CalibrationGain(void);
/*  Return 10.0 when no setting in EEPROM   */

float Read_AD_CalibrationOffset(void);
/*  Return 10.0 when no setting in EEPROM   */

float X202_AnalogIn(int iChannel);
/*  Return data = 0.0 ~ 20.0    */

extern float  fAD_Gain, fAD_Offset;
