/********************************************************/
/*	  7188EX + X308 head file                           */
/*                                                      */
/*	  [07/Oct/2005] by Liam                             */
/*	  [Oct,17,2003] by Jason Version : 1.00             */
/********************************************************/
/********************************************************/
/*	[Caution]                                           */
/*	The EEPROM block 7 on X board is used to  		    */
/*	store A/D calibration settings. When you use the    */
/*	EEPROM on X board, don't overwrite it.			    */
/********************************************************/

#define X308_DigitalIn      X308_Read_All_DI
#define X308_DigitalOut     X308_Write_All_DO

int X308_Init(void);
/*  Return value: 0   ==> success
    Return value: <>0 ==> error
        Bit0: 1 ==> Reads A/D Gain falure
        Bit1: 1 ==> Reads A/D Offset falure */

float Read_AD_CalibrationGain(void);
/*  Return 10.0 when no setting in EEPROM   */

float Read_AD_CalibrationOffset(void);
/*  Return 10.0 when no setting in EEPROM   */

float X308_AnalogIn(int iChannel);
/*  iChannel = 0~3 ----> ch1~ch4
    Return data = 0 ~ +10.0 */

void X308_Write_All_DO(int iOutValue);
/*  iOutValue: 0x00 ~ 0x3f  */

void X308_Write_One_DO(int iChannel, int iStatus);
/*  iChannel = 0 ~ 5
    iStatus = 1 => Status is ON
    iStatus = 0 => Status is OFF    */

int X308_Read_All_DO(void);
/*  Return data =  0x00 ~ 0x3f  */

int X308_Read_One_DO(int iChannel);
/*  iChannel = 0 ~ 5
    Return 1 => ON
    Return 0 => OFF */

extern float 	fAD_Gain, fAD_Offset;
