/******************************************************************/
/*	  7188EX + X310 head file                                     */
/*                                                                */
/*	  [11/October/2005] by Liam                                   */
/******************************************************************/
/******************************************************************/
/*  X310:   2 channel 12-Bit A/D (Analog input)                   */
/*              ch0: 0~20mA                                       */
/*              ch1: 0~10V                                        */
/*          2 channel 12-Bit D/A (Analog output)0.0~10.0V         */
/*          3 channel D/I                                         */
/*          3 channel D/O                                         */
/******************************************************************/
#define X310_DigitalIn      X310_Read_All_DI
#define X310_DigitalOut     X310_Write_All_DO

int X310_Init(void);
/*  Return value: 0   ==> success
    Return value: <>0 ==> error
    Bit0: 1 ==> (Ch0)Reads A/D Gain falure		==> uses default value
    Bit1: 1 ==> (Ch0)Reads A/D Offset falure	==> uses default value
    Bit2: 1 ==> (Ch0)Reads D/A Gain falure		==> uses default value
    Bit3: 1 ==> (Ch0)Reads D/A Offset falure 	==> uses default value
    Bit4: 1 ==> (Ch1)Reads A/D Gain falure		==> uses default value
    Bit5: 1 ==> (Ch1)Reads A/D Offset falure	==> uses default value
    Bit6: 1 ==> (Ch1)Reads D/A Gain falure		==> uses default value
    Bit7: 1 ==> (Ch1)Reads D/A Offset falure 	==> uses default value  */

float Read_AD_CalibrationGain(int iChannel);
/*  Return 10.0 when no setting in EEPROM   */

float Read_AD_CalibrationOffset(int iChannel);
/*  Return 10.0 when no setting in EEPROM   */

float Read_DA_CalibrationGain(int iChannel);
/*  Return 10.0 when no setting in EEPROM   */

float Read_DA_CalibrationOffset(int iChannel);
/*  Return 10.0 when no setting in EEPROM   */

float X310_AnalogIn(int iChannel);
/*  iChannel: 0~1   */

void X310_AnalogOut(int iChannel,float fValue);
/*  iChannel: 0~1
    fValue: +0.0 ~ +10.0    */

int X310_Read_All_DI(void);
/*  Return data =  0x00~0x07
    Return 1 => open
                Logic high level (+3.5V ~ +30V)
    Return 0 => close to GND
                Logic low level (0V ~ +1V)  */

int X310_Read_One_DI(int iChannel);
/*  iChannel = 0 ~ 2
    Return 1 => open
                Logic high level (+3.5V ~ +30V)
    Return 0 => close to GND
                Logic low level (0V ~ +1V)  */

void X310_Write_All_DO(int iOutValue);
/*  iOutValue: 0x00 ~ 0x07  */

void X310_Write_One_DO(int iChannel, int iStatus);
/*  iChannel = 0 ~ 2
    iStatus = 1 => Status is ON
    iStatus = 0 => Status is OFF    */

int X310_Read_All_DO(void);
/*  return data = 0x00 ~ 0x07   */

int X310_Read_One_DO(int iChannel);
/*  iChannel = 0 ~ 2
    Return 1 => ON
    Return 0 => OFF */

extern float	fAD_Gain[2], fAD_Offset[2];
extern float	fDA_Gain[2], fDA_Offset[2];

